//-----------------------------------------------------------------------------
//----- acrxEntryPoint.cpp
//-----------------------------------------------------------------------------
#include "StdAfx.h"
#include "resource.h"

//-----------------------------------------------------------------------------
#define szRDS _RXST("")

//-----------------------------------------------------------------------------
//----- ObjectARX EntryPoint
class CCommandIconApp : public AcRxArxApp {

public:
  CCommandIconApp () : AcRxArxApp () { isCmdBitmapQueryReg = FALSE; }

  virtual AcRx::AppRetCode On_kInitAppMsg (void *pkt) {
    AcRx::AppRetCode retCode = AcRxArxApp::On_kInitAppMsg (pkt) ;
    //  ,      HBITMAP
    isCmdBitmapQueryReg = 
      acedRegisterCommandBitmapQuery(CommandBitmapQueryFn);
    return (retCode) ;
  }

  virtual AcRx::AppRetCode On_kUnloadAppMsg (void *pkt) {
    //  ,      HBITMAP
    if (isCmdBitmapQueryReg) 
      acedRemoveCommandBitmapQuery(CommandBitmapQueryFn);

    AcRx::AppRetCode retCode = AcRxArxApp::On_kUnloadAppMsg (pkt) ;

    return (retCode) ;
  }

  virtual void RegisterServerComponents () {	}

  static void RivilisCommandIcon () {
    acutPrintf(_T("\n CommandIcon"));
  }  
  /// <summary>
  ///      HBITMAP  
  /// </summary>
  /// <param name="cmdName"> </param>
  /// <param name="backgroundColor"> </param>
  /// <returns></returns>
  static HBITMAP CommandBitmapQueryFn(const TCHAR* cmdName, const COLORREF& backgroundColor)
  {
    //     .  .
    if (AcString(cmdName).compareNoCase(_T("CommandIcon")) == 0) {
      if (!hBitmap) InitializeBitmap(); //  
      return hBitmap;
    }
    return NULL;
  }

private:  
  /// <summary>
  ///  HBITMAP  
  /// </summary>
  static void InitializeBitmap()
  {
    HICON hIcon = LoadIcon(_hdllInstance, MAKEINTRESOURCE(IDI_COMMANDICON));
    ICONINFO info; GetIconInfo(hIcon, &info);
    BITMAP bmp;  GetObject(info.hbmColor, sizeof(bmp), &bmp);
    hBitmap = (HBITMAP)CopyImage(info.hbmColor, IMAGE_BITMAP, 0, 0, 0);
  }
  BOOL isCmdBitmapQueryReg;
  static HBITMAP hBitmap;	
} ;

HBITMAP CCommandIconApp::hBitmap = NULL;	

//-----------------------------------------------------------------------------
IMPLEMENT_ARX_ENTRYPOINT(CCommandIconApp)

ACED_ARXCOMMAND_ENTRY_AUTO(CCommandIconApp, Rivilis, CommandIcon, CommandIcon, ACRX_CMD_MODAL, NULL)

